﻿<%@ Page Language="C#" %>

<%@ Register TagPrefix="telerik" Namespace="Telerik.Web.UI" Assembly="Telerik.Web.UI" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Entire week selection on selecting a single date</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:ScriptManager ID="ScriptManager1" runat="server">
        </asp:ScriptManager>
        <telerik:RadCodeBlock ID="RadCodeBlock1" runat="server">
            <script type="text/javascript">
                function AddEvent(e)
                {
                    var calendar = $get("<%=RadCalendar1.ClientID %>");
                    if (typeof (calendar.addEventListener) != "undefined") //gecko browsers
                    {
                        calendar.addEventListener("click", SelectWholeWeek, false);
                    }
                    else if (calendar.attachEvent) //IE
                    {
                        calendar.attachEvent("onclick", SelectWholeWeek);
                    }
                }

                function SelectWholeWeek(args)
                {
                    var target = FindTarget(args); //find the clicked cell	  
                    if (target.DayId && target.className)//if the clicked cell is a date cell it has a DayId
                    {
                        if ((target.className == "radCalSelect_Default") || (target.className == "rcSelected"))
                        {
                            var calendar = $find("<%= RadCalendar1.ClientID %>");
                            calendar.unselectDates(calendar.get_selectedDates());

                            var row = target.parentNode;
                            while (row.tagName != "TR")
                            {
                                row = row.parentNode;
                            }
                            var rowCells = row.getElementsByTagName("td"); //get all the cells of the row
                            for (var i = 0; i < rowCells.length; i++)
                                if (rowCells[i].DayId) //if the cell is a selectable Date cell it has DayId  
                                {
                                    var date = GetDateFromID(rowCells[i].DayId);
                                    calendar.selectDate(date);
                                }
                        }
                    }
                }

                function FindTarget(e)
                {

                    var target;
                    if (e && e.target) //other browsers
                    {
                        target = e.target;
                    }
                    else if (window.event && window.event.srcElement) //IE
                    {
                        target = window.event.srcElement;
                    }

                    if (!target)
                    {
                        return null;
                    }

                    while (target != null)
                    {
                        if (target.tagName.toLowerCase() == 'td')
                        {
                            break;
                        }
                        target = target.parentNode;
                    }

                    if (target.tagName.toLowerCase() != 'td')
                    {
                        return null;
                    }
                    return target;
                }

                function GetDateFromID(ID)
                {

                    var name = ID.split("_");
                    var date = [parseInt(name[1]), parseInt(name[2]), parseInt(name[3])];
                    return date;
                }
            </script>
        </telerik:RadCodeBlock>
        <telerik:RadCalendar ID="RadCalendar1" runat="server">
            <ClientEvents OnLoad="AddEvent" />
        </telerik:RadCalendar>
    </div>
    </form>
</body>
</html>
